//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FindCircle0.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
const double PI=3.141592653;
double x0=300,y0=300,r=80,R=100,s,xp,yp,xc,yc;

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  xp = X-x0;
  yp = Y-y0;
  Form1->Canvas->Ellipse(x0-r-2*R, y0-r-2*R, x0+r+2*R, y0+r+2*R);
  Form1->Canvas->Ellipse(x0-r, y0-r, x0+r, y0+r);
  Form1->Canvas->MoveTo(x0,y0);
  Form1->Canvas->LineTo(xp+x0,yp+y0);
}
//---------------------------------------------------------------------------
AnsiString msg;
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  s = sqrt( (xp)*(xp)+(yp)*(yp) );
  double theta, phi, angle;
  theta = acos( (R*R-s*s-(r+R)*(r+R))/(2*s*(r+R)) );
  if ( yp<0 ) theta += PI;
  phi = atan2(yp, xp);
  if ( yp<0 ) phi += 2*PI;
  angle = phi - theta;
  if ( yp>0 ) angle += PI;
  xc = (r+R)*cos(angle) + x0;
  yc = (r+R)*sin(angle) + y0;

  Form1->Canvas->Ellipse(xc-R,yc-R,xc+R,yc+R);
  Form1->Canvas->Ellipse(xc-2,yc-2,xc+2,yc+2);
  Form1->Canvas->MoveTo(x0,y0);
  Form1->Canvas->LineTo(xp+x0,yp+y0);

  msg.printf("r=%.0f, R=%.0f\n(xp,yp)=(%+5.1f, %+5.1f)\n(xc,yc)=(%+5.1f, %+5.1f)",
               r, R, xp, -yp, xc-x0, -(yc-y0));
  Label1->Caption = msg;
}
//---------------------------------------------------------------------------
